--- old/usr/src/uts/common/io/aac/aac.c	Thu Nov  1 14:48:24 2012
+++ new/usr/src/uts/common/io/aac/aac.c	Thu Nov  1 14:48:24 2012
@@ -2169,6 +2081,14 @@
 		softs->aac_if = aac_rkt_interface;
 		softs->map_size_min = AAC_MAP_SIZE_MIN_RKT;
 		break;
+	case AAC_HWIF_SRC:
+		softs->aac_if = aac_src_interface;
+		softs->map_size_min = AAC_MAP_SIZE_MIN_SRC_BAR0;
+		break;
+	case AAC_HWIF_SRCV:
+		softs->aac_if = aac_srcv_interface;
+		softs->map_size_min = AAC_MAP_SIZE_MIN_SRCV_BAR0;
+		break;
 	default:
 		AACDB_PRINT(softs, CE_WARN,
 		    "Unknown hardware interface %d", softs->hwif);
@@ -2197,8 +2117,14 @@
 	}
 
 	/* Set memory base to map */
-	softs->pci_mem_base_paddr = 0xfffffff0UL & \
+	softs->pci_mem_base_paddr[0] = 0xfffffff0UL & \
 	    pci_config_get32(pci_config_handle, PCI_CONF_BASE0);
+	if (softs->hwif == AAC_HWIF_SRC) {
+		softs->pci_mem_base_paddr[1] = 0xfffffff0UL & \
+		    pci_config_get32(pci_config_handle, PCI_CONF_BASE2);
+	} else {
+		softs->pci_mem_base_paddr[1] = softs->pci_mem_base_paddr[0];
+	}
 
 	pci_config_teardown(&pci_config_handle);
 
@@ -2209,77 +2135,6 @@
 }
 
 /*
- * Do the usual interrupt handler setup stuff.
- */
-static int
-aac_register_intrs(struct aac_softstate *softs)
-{
-	dev_info_t *dip;
-	int intr_types;
-
-	ASSERT(softs->devinfo_p);
-	dip = softs->devinfo_p;
-
-	/* Get the type of device intrrupts */
-	if (ddi_intr_get_supported_types(dip, &intr_types) != DDI_SUCCESS) {
-		AACDB_PRINT(softs, CE_WARN,
-		    "ddi_intr_get_supported_types() failed");
-		return (AACERR);
-	}
-	AACDB_PRINT(softs, CE_NOTE,
-	    "ddi_intr_get_supported_types() ret: 0x%x", intr_types);
-
-	/* Query interrupt, and alloc/init all needed struct */
-	if (intr_types & DDI_INTR_TYPE_MSI) {
-		if (aac_query_intrs(softs, DDI_INTR_TYPE_MSI)
-		    != DDI_SUCCESS) {
-			AACDB_PRINT(softs, CE_WARN,
-			    "MSI interrupt query failed");
-			return (AACERR);
-		}
-		softs->intr_type = DDI_INTR_TYPE_MSI;
-	} else if (intr_types & DDI_INTR_TYPE_FIXED) {
-		if (aac_query_intrs(softs, DDI_INTR_TYPE_FIXED)
-		    != DDI_SUCCESS) {
-			AACDB_PRINT(softs, CE_WARN,
-			    "FIXED interrupt query failed");
-			return (AACERR);
-		}
-		softs->intr_type = DDI_INTR_TYPE_FIXED;
-	} else {
-		AACDB_PRINT(softs, CE_WARN,
-		    "Device cannot suppport both FIXED and MSI interrupts");
-		return (AACERR);
-	}
-
-	/* Connect interrupt handlers */
-	if (aac_add_intrs(softs) != DDI_SUCCESS) {
-		AACDB_PRINT(softs, CE_WARN,
-		    "Interrupt registration failed, intr type: %s",
-		    softs->intr_type == DDI_INTR_TYPE_MSI ? "MSI" : "FIXED");
-		return (AACERR);
-	}
-	(void) aac_enable_intrs(softs);
-
-	if (ddi_add_softintr(dip, DDI_SOFTINT_LOW, &softs->softint_id,
-	    NULL, NULL, aac_softintr, (caddr_t)softs) != DDI_SUCCESS) {
-		AACDB_PRINT(softs, CE_WARN,
-		    "Can not setup soft interrupt handler!");
-		aac_remove_intrs(softs);
-		return (AACERR);
-	}
-
-	return (AACOK);
-}
-
-static void
-aac_unregister_intrs(struct aac_softstate *softs)
-{
-	aac_remove_intrs(softs);
-	ddi_remove_softintr(softs->softint_id);
-}
-
-/*
  * Check the firmware to determine the features to support and the FIB
  * parameters to use.
  */
@@ -2289,8 +2144,8 @@
 	uint32_t options;
 	uint32_t atu_size;
 	ddi_acc_handle_t pci_handle;
-	uint8_t *data;
-	uint32_t max_fibs;
+	char *pci_mbr;
+	uint32_t max_fibs, max_aif;
 	uint32_t max_fib_size;
 	uint32_t sg_tablesize;
 	uint32_t max_sectors;
@@ -2297,8 +2152,9 @@
 	uint32_t status;
 
 	/* Get supported options */
+	softs->sync_slot_busy = 1;
 	if ((aac_sync_mbcommand(softs, AAC_MONKER_GETINFO, 0, 0, 0, 0,
-	    &status)) != AACOK) {
+	    &status, NULL)) != AACOK) {
 		if (status != SRB_STATUS_INVALID_REQUEST) {
 			cmn_err(CE_CONT,
 			    "?Fatal error: request adapter info error");
@@ -2357,21 +2213,41 @@
 	}
 
 	if (options & AAC_SUPPORTED_NONDASD) {
-		if ((ddi_prop_lookup_string(DDI_DEV_T_ANY, softs->devinfo_p, 0,
-		    "nondasd-enable", (char **)&data) == DDI_SUCCESS)) {
-			if (strcmp((char *)data, "yes") == 0) {
-				AACDB_PRINT(softs, CE_NOTE,
-				    "!Enable Non-DASD access");
-				softs->flags |= AAC_FLAGS_NONDASD;
-			}
-			ddi_prop_free(data);
-		}
+		softs->flags |= AAC_FLAGS_NONDASD;
+		AACDB_PRINT(softs, CE_NOTE, "!Enable Non-DASD access");
 	}
 
+	if ((options & AAC_SUPPORTED_NEW_COMM_TYPE3) ||
+		(options & AAC_SUPPORTED_NEW_COMM_TYPE4)) {
+		softs->flags |= AAC_FLAGS_NEW_COMM | AAC_FLAGS_NEW_COMM_TYPE34;
+	} else if (options & AAC_SUPPORTED_NEW_COMM_TYPE2) {
+		softs->flags |= AAC_FLAGS_NEW_COMM | AAC_FLAGS_NEW_COMM_TYPE2;
+		AACDB_PRINT(softs, CE_NOTE,	"!Enable New Comm. Type2 interface");
+	} else if (options & AAC_SUPPORTED_NEW_COMM_TYPE1) {
+		softs->flags |= AAC_FLAGS_NEW_COMM | AAC_FLAGS_NEW_COMM_TYPE1;
+		AACDB_PRINT(softs, CE_NOTE,	"!Enable New Comm. Type1 interface");
+	} else if (options & AAC_SUPPORTED_NEW_COMM) {
+		softs->flags |= AAC_FLAGS_NEW_COMM;
+		AACDB_PRINT(softs, CE_NOTE,	"!Enable New Comm. interface");
+	}
+
+	if (softs->sync_mode &&
+		((softs->flags & AAC_FLAGS_NEW_COMM_TYPE1) || 
+		 (softs->flags & AAC_FLAGS_NEW_COMM_TYPE2) || 
+		 (softs->flags & AAC_FLAGS_NEW_COMM_TYPE34))) {
+		cmn_err(CE_NOTE, "aac: Sync. mode enforced by driver parameter. This will cause a significant performance decrease!");
+		softs->flags |= AAC_FLAGS_SYNC_MODE;
+	} else if (softs->flags & AAC_FLAGS_NEW_COMM_TYPE34) {
+		cmn_err(CE_NOTE, "aac: Async. mode not supported by current driver, sync. mode enforced.");
+		cmn_err(CE_NOTE, "aac: Please update driver to get full performance.");
+		softs->flags |= AAC_FLAGS_SYNC_MODE;
+	}
+
 	/* Read preferred settings */
 	max_fib_size = 0;
+	softs->sync_slot_busy = 1;
 	if ((aac_sync_mbcommand(softs, AAC_MONKER_GETCOMMPREF,
-	    0, 0, 0, 0, NULL)) == AACOK) {
+	    0, 0, 0, 0, NULL, NULL)) == AACOK) {
 		options = AAC_MAILBOX_GET(softs, 1);
 		max_fib_size = (options & 0xffff);
 		max_sectors = (options >> 16) << 1;
@@ -2379,26 +2255,28 @@
 		sg_tablesize = (options >> 16);
 		options = AAC_MAILBOX_GET(softs, 3);
 		max_fibs = (options & 0xffff);
+		options = AAC_MAILBOX_GET(softs, 4);
+		max_aif = (options & 0xffff);
 	}
 
 	/* Enable new comm. and rawio at the same time */
-	if ((softs->support_opt & AAC_SUPPORTED_NEW_COMM) &&
+	if ((softs->flags & AAC_FLAGS_NEW_COMM) &&
 	    (max_fib_size != 0)) {
-		/* read out and save PCI MBR */
-		if ((atu_size > softs->map_size) &&
-		    (ddi_regs_map_setup(softs->devinfo_p, 1,
-		    (caddr_t *)&data, 0, atu_size, &softs->reg_attr,
-		    &pci_handle) == DDI_SUCCESS)) {
-			ddi_regs_map_free(&softs->pci_mem_handle);
-			softs->pci_mem_handle = pci_handle;
-			softs->pci_mem_base_vaddr = data;
+        if ((atu_size > softs->map_size) &&
+			(ddi_regs_map_setup(softs->devinfo_p, 1,
+				(caddr_t *)&pci_mbr, 0, atu_size, &aac_acc_attr,
+				&pci_handle) == DDI_SUCCESS)) {
+			ddi_regs_map_free(&softs->pci_mem_handle[0]);
+			softs->pci_mem_handle[0] = pci_handle;
+			softs->pci_mem_base_vaddr[0] = pci_mbr;
 			softs->map_size = atu_size;
+			if (softs->hwif != AAC_HWIF_SRC) {
+				softs->pci_mem_handle[1] =
+					softs->pci_mem_handle[0];
+				softs->pci_mem_base_vaddr[1] =
+					softs->pci_mem_base_vaddr[0];
+			}
 		}
-		if (atu_size == softs->map_size) {
-			softs->flags |= AAC_FLAGS_NEW_COMM;
-			AACDB_PRINT(softs, CE_NOTE,
-			    "!Enable New Comm. interface");
-		}
 	}
 
 	/* Set FIB parameters */
@@ -2407,6 +2285,7 @@
 		softs->aac_max_fib_size = max_fib_size;
 		softs->aac_max_sectors = max_sectors;
 		softs->aac_sg_tablesize = sg_tablesize;
+		softs->aac_max_aif = max_aif;
 
 		softs->flags |= AAC_FLAGS_RAW_IO;
 		AACDB_PRINT(softs, CE_NOTE, "!Enable RawIO");
@@ -2452,7 +2331,9 @@
 	    softs->buf_dma_attr.dma_attr_maxxfer - 1;
 
 	/* Setup FIB operations */
-	if (softs->flags & AAC_FLAGS_RAW_IO)
+	if (softs->flags & AAC_FLAGS_NEW_COMM_TYPE2) 
+		softs->aac_cmd_fib = aac_cmd_fib_rawio2;
+	else if (softs->flags & AAC_FLAGS_RAW_IO)
 		softs->aac_cmd_fib = aac_cmd_fib_rawio;
 	else if (softs->flags & AAC_FLAGS_SG_64BIT)
 		softs->aac_cmd_fib = aac_cmd_fib_brw64;
@@ -2479,7 +2360,7 @@
 aac_fsa_rev(struct aac_softstate *softs, struct FsaRev *fsarev0,
     struct FsaRev *fsarev1)
 {
-	ddi_acc_handle_t acc = softs->sync_ac.slotp->fib_acc_handle;
+	ddi_acc_handle_t acc = softs->comm_space_acc_handle;
 
 	AAC_GET_FIELD8(acc, fsarev1, fsarev0, external.comp.dash);
 	AAC_GET_FIELD8(acc, fsarev1, fsarev0, external.comp.type);
@@ -2497,23 +2378,16 @@
 aac_get_adapter_info(struct aac_softstate *softs,
     struct aac_adapter_info *ainfr, struct aac_supplement_adapter_info *sinfr)
 {
-	struct aac_cmd *acp = &softs->sync_ac;
-	ddi_acc_handle_t acc;
-	struct aac_fib *fibp;
+	ddi_acc_handle_t acc = softs->sync_slot->fib_acc_handle;
+	struct aac_fib *fibp = softs->sync_slot->fibp;
 	struct aac_adapter_info *ainfp;
 	struct aac_supplement_adapter_info *sinfp;
-	int rval;
 
-	(void) aac_sync_fib_slot_bind(softs, acp);
-	acc = acp->slotp->fib_acc_handle;
-	fibp = acp->slotp->fibp;
-
 	ddi_put8(acc, &fibp->data[0], 0);
 	if (aac_sync_fib(softs, RequestAdapterInfo,
 	    AAC_FIB_SIZEOF(struct aac_adapter_info)) != AACOK) {
 		AACDB_PRINT(softs, CE_WARN, "RequestAdapterInfo failed");
-		rval = AACERR;
-		goto finish;
+		return (AACERR);
 	}
 	ainfp = (struct aac_adapter_info *)fibp->data;
 	if (ainfr) {
@@ -2545,17 +2419,14 @@
 		    AAC_SUPPORTED_SUPPLEMENT_ADAPTER_INFO)) {
 			AACDB_PRINT(softs, CE_WARN,
 			    "SupplementAdapterInfo not supported");
-			rval = AACERR;
-			goto finish;
+			return (AACERR);
 		}
 		ddi_put8(acc, &fibp->data[0], 0);
 		if (aac_sync_fib(softs, RequestSupplementAdapterInfo,
-		    AAC_FIB_SIZEOF(struct aac_supplement_adapter_info))
-		    != AACOK) {
+		    AAC_FIB_SIZEOF(struct aac_supplement_adapter_info)) != AACOK) {
 			AACDB_PRINT(softs, CE_WARN,
 			    "RequestSupplementAdapterInfo failed");
-			rval = AACERR;
-			goto finish;
+			return (AACERR);
 		}
 		sinfp = (struct aac_supplement_adapter_info *)fibp->data;
 		AAC_REP_GET_FIELD8(acc, sinfr, sinfp, AdapterTypeText[0], 17+1);
@@ -2584,16 +2455,11 @@
 		AAC_GET_FIELD32(acc, sinfr, sinfp, ExpansionFlag);
 		if (sinfr->ExpansionFlag == 1) {
 			AAC_GET_FIELD32(acc, sinfr, sinfp, FeatureBits3);
-			AAC_GET_FIELD32(acc, sinfr, sinfp,
-			    SupportedPerformanceMode);
-			AAC_REP_GET_FIELD32(acc, sinfr, sinfp,
-			    ReservedGrowth[0], 80);
+			AAC_GET_FIELD32(acc, sinfr, sinfp, SupportedPerformanceMode);
+			AAC_REP_GET_FIELD32(acc, sinfr, sinfp, ReservedGrowth[0], 80);
 		}
 	}
-	rval = AACOK;
-finish:
-	aac_sync_fib_slot_release(softs, acp);
-	return (rval);
+	return (AACOK);
 }
 
 static int
@@ -2600,9 +2466,8 @@
 aac_get_bus_info(struct aac_softstate *softs, uint32_t *bus_max,
     uint32_t *tgt_max)
 {
-	struct aac_cmd *acp = &softs->sync_ac;
-	ddi_acc_handle_t acc;
-	struct aac_fib *fibp;
+	ddi_acc_handle_t acc = softs->sync_slot->fib_acc_handle;
+	struct aac_fib *fibp = softs->sync_slot->fibp;
 	struct aac_ctcfg *c_cmd;
 	struct aac_ctcfg_resp *c_resp;
 	uint32_t scsi_method_id;
@@ -2610,10 +2475,6 @@
 	struct aac_bus_info_response *resp;
 	int rval;
 
-	(void) aac_sync_fib_slot_bind(softs, acp);
-	acc = acp->slotp->fib_acc_handle;
-	fibp = acp->slotp->fibp;
-
 	/* Detect MethodId */
 	c_cmd = (struct aac_ctcfg *)&fibp->data[0];
 	ddi_put32(acc, &c_cmd->Command, VM_ContainerConfig);
@@ -2625,8 +2486,7 @@
 	if (rval != AACOK || ddi_get32(acc, &c_resp->Status) != 0) {
 		AACDB_PRINT(softs, CE_WARN,
 		    "VM_ContainerConfig command fail");
-		rval = AACERR;
-		goto finish;
+		return (AACERR);
 	}
 	scsi_method_id = ddi_get32(acc, &c_resp->param);
 
@@ -2650,14 +2510,10 @@
 	/* Scan all coordinates with INQUIRY */
 	if ((rval != AACOK) || (ddi_get32(acc, &resp->Status) != 0)) {
 		AACDB_PRINT(softs, CE_WARN, "GetBusInfo command fail");
-		rval = AACERR;
-		goto finish;
+		return (AACERR);
 	}
 	*bus_max = ddi_get32(acc, &resp->BusCount);
 	*tgt_max = ddi_get32(acc, &resp->TargetsPerBus);
-
-finish:
-	aac_sync_fib_slot_release(softs, acp);
 	return (AACOK);
 }
 
@@ -2702,9 +2558,8 @@
 static int
 aac_handle_adapter_config_issues(struct aac_softstate *softs)
 {
-	struct aac_cmd *acp = &softs->sync_ac;
-	ddi_acc_handle_t acc;
-	struct aac_fib *fibp;
+	ddi_acc_handle_t acc = softs->sync_slot->fib_acc_handle;
+	struct aac_fib *fibp = softs->sync_slot->fibp;
 	struct aac_Container *cmd;
 	struct aac_Container_resp *resp;
 	struct aac_cf_status_header *cfg_sts_hdr;
@@ -2713,10 +2568,6 @@
 	uint32_t cfg_stat_action;
 	int rval;
 
-	(void) aac_sync_fib_slot_bind(softs, acp);
-	acc = acp->slotp->fib_acc_handle;
-	fibp = acp->slotp->fibp;
-
 	/* Get adapter config status */
 	cmd = (struct aac_Container *)&fibp->data[0];
 
@@ -2764,8 +2615,6 @@
 		cmn_err(CE_WARN, "!Configuration issue, auto-commit aborted");
 		rval = AACMPE_CONFIG_STATUS;
 	}
-
-	aac_sync_fib_slot_release(softs, acp);
 	return (rval);
 }
 
@@ -2777,6 +2626,7 @@
 {
 	uint32_t status;
 	int i;
+	char version_string[160];
 	struct aac_supplement_adapter_info sinf;
 
 	DBCALLED(softs, 1);
@@ -2788,8 +2638,10 @@
 	 * the driver like when the system crashes and the crash dump driver
 	 * gets loaded.
 	 */
-	while (AAC_OUTB_GET(softs) != 0xfffffffful)
-		;
+	if (softs->hwif != AAC_HWIF_SRC && softs->hwif != AAC_HWIF_SRCV) {
+		while (AAC_OUTB_GET(softs) != 0xfffffffful)
+			;
+	}
 
 	/*
 	 * Wait the card to complete booting up before do anything that
@@ -2802,42 +2654,25 @@
 	AAC_BUSYWAIT(AAC_FWSTATUS_GET(softs) & AAC_KERNEL_UP_AND_RUNNING, i);
 	if (i == 0) {
 		cmn_err(CE_CONT, "?Fatal error: controller not ready");
-		aac_fm_ereport(softs, DDI_FM_DEVICE_NO_RESPONSE);
-		ddi_fm_service_impact(softs->devinfo_p, DDI_SERVICE_LOST);
+		aac_fm_ereport(softs, DDI_FM_DEVICE_NO_RESPONSE, DDI_SERVICE_LOST);
 		goto error;
 	}
 
 	/* Read and set card supported options and settings */
 	if (aac_check_firmware(softs) == AACERR) {
-		aac_fm_ereport(softs, DDI_FM_DEVICE_NO_RESPONSE);
-		ddi_fm_service_impact(softs->devinfo_p, DDI_SERVICE_LOST);
+		aac_fm_ereport(softs, DDI_FM_DEVICE_NO_RESPONSE, DDI_SERVICE_LOST);
 		goto error;
 	}
 
-	/* Add interrupt handlers */
-	if (aac_register_intrs(softs) == AACERR) {
-		cmn_err(CE_CONT,
-		    "?Fatal error: interrupts register failed");
-		goto error;
-	}
+	/* Clear out all interrupts */
+	AAC_STATUS_CLR(softs, ~0);
 
-	/* Setup communication space with the card */
+	/* Allocate communication space with the card */
 	if (softs->comm_space_dma_handle == NULL) {
 		if (aac_alloc_comm_space(softs) != AACOK)
 			goto error;
 	}
-	if (aac_setup_comm_space(softs) != AACOK) {
-		cmn_err(CE_CONT, "?Setup communication space failed");
-		aac_fm_ereport(softs, DDI_FM_DEVICE_NO_RESPONSE);
-		ddi_fm_service_impact(softs->devinfo_p, DDI_SERVICE_LOST);
-		goto error;
-	}
 
-#ifdef DEBUG
-	if (aac_get_fw_debug_buffer(softs) != AACOK)
-		cmn_err(CE_CONT, "?firmware UART trace not supported");
-#endif
-
 	/* Allocate slots */
 	if ((softs->total_slots == 0) && (aac_create_slots(softs) != AACOK)) {
 		cmn_err(CE_CONT, "?Fatal error: slots allocate failed");
@@ -2854,13 +2689,12 @@
 		    softs->total_fibs);
 	}
 
-	AAC_STATUS_CLR(softs, ~0); /* Clear out all interrupts */
-	AAC_ENABLE_INTR(softs); /* Enable the interrupts we can handle */
+	if (aac_get_adapter_info(softs, NULL, &sinf) != AACOK) {
+		cmn_err(CE_CONT, "?Query adapter information failed");
+	} else {
+		softs->aac_feature_bits = sinf.FeatureBits;
+		softs->aac_support_opt2 = sinf.SupportedOptions2;
 
-	if (aac_get_adapter_info(softs, NULL, &sinf) == AACOK) {
-		softs->feature_bits = sinf.FeatureBits;
-		softs->support_opt2 = sinf.SupportedOptions2;
-
 		/* Get adapter names */
 		if (CARD_IS_UNKNOWN(softs->card)) {
 			char *p, *p0, *p1;
@@ -2901,12 +2735,23 @@
 					    p0, AAC_PRODUCT_LEN);
 			}
 		}
-	} else {
-		cmn_err(CE_CONT, "?Query adapter information failed");
 	}
 
+	if (!(softs->flags & AAC_FLAGS_SYNC_MODE)) {
+		/* Setup communication space with the card */
+		if (aac_setup_comm_space(softs) != AACOK) {
+			cmn_err(CE_CONT, "?Setup communication space failed");
+			aac_fm_ereport(softs, DDI_FM_DEVICE_NO_RESPONSE, DDI_SERVICE_LOST);
+			goto error;
+		}
+	}
 
-	cmn_err(CE_NOTE,
+#ifdef AAC_DEBUG
+	if (aac_get_fw_debug_buffer(softs) != AACOK)
+		cmn_err(CE_CONT, "?firmware UART trace not supported");
+#endif
+
+	sprintf(version_string,
 	    "!aac driver %d.%02d.%02d-%d, found card: " \
 	    "%s %s(pci0x%x.%x.%x.%x) at 0x%x",
 	    AAC_DRIVER_MAJOR_VERSION,
@@ -2915,13 +2760,14 @@
 	    AAC_DRIVER_BUILD,
 	    softs->vendor_name, softs->product_name,
 	    softs->vendid, softs->devid, softs->subvendid, softs->subsysid,
-	    softs->pci_mem_base_paddr);
+	    softs->pci_mem_base_paddr[0]);
+	cmn_err(CE_NOTE, version_string);
+	AACDB_PRINT(softs, CE_NOTE, version_string);
 
 	/* Perform acceptance of adapter-detected config changes if possible */
 	if (aac_handle_adapter_config_issues(softs) != AACMPE_OK) {
 		cmn_err(CE_CONT, "?Handle adapter config issues failed");
-		aac_fm_ereport(softs, DDI_FM_DEVICE_NO_RESPONSE);
-		ddi_fm_service_impact(softs->devinfo_p, DDI_SERVICE_LOST);
+		aac_fm_ereport(softs, DDI_FM_DEVICE_NO_RESPONSE, DDI_SERVICE_LOST);
 		goto error;
 	}
 
@@ -2931,22 +2777,8 @@
 		goto error;
 	}
 
-	/* Check for JBOD support. Default disable */
-	char *data;
-	if (softs->feature_bits & AAC_FEATURE_SUPPORTED_JBOD) {
-		if ((ddi_prop_lookup_string(DDI_DEV_T_ANY, softs->devinfo_p,
-		    0, "jbod-enable", &data) == DDI_SUCCESS)) {
-			if (strcmp(data, "yes") == 0) {
-				AACDB_PRINT(softs, CE_NOTE,
-				    "Enable JBOD access");
-				softs->flags |= AAC_FLAGS_JBOD;
-			}
-			ddi_prop_free(data);
-		}
-	}
-
 	/* Setup phys. devices */
-	if (softs->flags & (AAC_FLAGS_NONDASD | AAC_FLAGS_JBOD)) {
+	if (softs->flags & AAC_FLAGS_NONDASD) {
 		uint32_t bus_max, tgt_max;
 		uint32_t bus, tgt;
 		int index;
@@ -2987,12 +2819,12 @@
 
 	/* Check dma & acc handles allocated in attach */
 	if (aac_check_dma_handle(softs->comm_space_dma_handle) != DDI_SUCCESS) {
-		ddi_fm_service_impact(softs->devinfo_p, DDI_SERVICE_LOST);
+		aac_fm_service_impact(softs->devinfo_p, DDI_SERVICE_LOST);
 		goto error;
 	}
 
-	if (aac_check_acc_handle(softs->pci_mem_handle) != DDI_SUCCESS) {
-		ddi_fm_service_impact(softs->devinfo_p, DDI_SERVICE_LOST);
+	if (aac_check_acc_handle(softs->pci_mem_handle[0]) != DDI_SUCCESS) {
+		aac_fm_service_impact(softs->devinfo_p, DDI_SERVICE_LOST);
 		goto error;
 	}
 
@@ -2999,7 +2831,7 @@
 	for (i = 0; i < softs->total_slots; i++) {
 		if (aac_check_dma_handle(softs->io_slot[i].fib_dma_handle) !=
 		    DDI_SUCCESS) {
-			ddi_fm_service_impact(softs->devinfo_p,
+			aac_fm_service_impact(softs->devinfo_p,
 			    DDI_SERVICE_LOST);
 			goto error;
 		}
@@ -3031,9 +2863,6 @@
 {
 	DBCALLED(softs, 1);
 
-	aac_unregister_intrs(softs);
-
-	mutex_enter(&softs->io_lock);
 	(void) aac_shutdown(softs);
 
 	if (softs->nondasds) {
@@ -3044,7 +2873,6 @@
 	aac_destroy_fibs(softs);
 	aac_destroy_slots(softs);
 	aac_free_comm_space(softs);
-	mutex_exit(&softs->io_lock);
 }
 
 /*
@@ -3054,14 +2882,11 @@
 int
 aac_sync_mbcommand(struct aac_softstate *softs, uint32_t cmd,
     uint32_t arg0, uint32_t arg1, uint32_t arg2, uint32_t arg3,
-    uint32_t *statusp)
+    uint32_t *statusp, uint32_t *r1)
 {
 	int timeout;
 	uint32_t status;
 
-	if (statusp != NULL)
-		*statusp = SRB_STATUS_SUCCESS;
-
 	/* Fill in mailbox */
 	AAC_MAILBOX_SET(softs, cmd, arg0, arg1, arg2, arg3);
 
@@ -3071,27 +2896,36 @@
 	/* Then set it to signal the adapter */
 	AAC_NOTIFY(softs, AAC_DB_SYNC_COMMAND);
 
-	/* Spin waiting for the command to complete */
-	timeout = AAC_IMMEDIATE_TIMEOUT * 1000;
-	AAC_BUSYWAIT(AAC_STATUS_GET(softs) & AAC_DB_SYNC_COMMAND, timeout);
-	if (!timeout) {
-		AACDB_PRINT(softs, CE_WARN,
-		    "Sync command timed out after %d seconds (0x%x)!",
-		    AAC_IMMEDIATE_TIMEOUT, AAC_FWSTATUS_GET(softs));
-		return (AACERR);
-	}
+	if ((cmd != AAC_MONKER_SYNCFIB) || (statusp == NULL) || (*statusp != 0)) {
+		if (statusp != NULL)
+			*statusp = SRB_STATUS_SUCCESS;
+		/* Spin waiting for the command to complete */
+		timeout = AAC_IMMEDIATE_TIMEOUT * 1000;
+		AAC_BUSYWAIT(AAC_STATUS_GET(softs) & AAC_DB_SYNC_COMMAND, timeout);
+		if (!timeout) {
+			AACDB_PRINT(softs, CE_WARN,
+				"Sync command %d timed out after %d seconds (0x%x)!",
+				cmd, AAC_IMMEDIATE_TIMEOUT, AAC_FWSTATUS_GET(softs));
+			softs->sync_slot_busy = 0;
+			return (AACERR);
+		}
 
-	/* Clear the completion flag */
-	AAC_STATUS_CLR(softs, AAC_DB_SYNC_COMMAND);
+		/* Clear the completion flag */
+		AAC_STATUS_CLR(softs, AAC_DB_SYNC_COMMAND);
 
-	/* Get the command status */
-	status = AAC_MAILBOX_GET(softs, 0);
-	if (statusp != NULL)
-		*statusp = status;
-	if (status != SRB_STATUS_SUCCESS) {
-		AACDB_PRINT(softs, CE_WARN,
-		    "Sync command fail: status = 0x%x", status);
-		return (AACERR);
+		/* Get the command status */
+		status = AAC_MAILBOX_GET(softs, 0);
+		if (statusp != NULL)
+			*statusp = status;
+		if (status != SRB_STATUS_SUCCESS) {
+			AACDB_PRINT(softs, CE_WARN,
+				"Sync command %d failed: status = 0x%x", cmd, status);
+			softs->sync_slot_busy = 0;
+			return (AACERR);
+		}	
+		if (r1 != NULL) 
+			*r1 = AAC_MAILBOX_GET(softs, 1);
+		softs->sync_slot_busy = 0;
 	}
 
 	return (AACOK);
@@ -3099,37 +2933,48 @@
 
 /*
  * Send a synchronous FIB to the adapter and wait for its completion
- */
+ */            
 static int
 aac_sync_fib(struct aac_softstate *softs, uint16_t cmd, uint16_t fibsize)
 {
-	struct aac_cmd *acp = &softs->sync_ac;
+	struct aac_slot *slotp = softs->sync_slot;
+	ddi_dma_handle_t dma = slotp->fib_dma_handle;
+	uint32_t status = 1;
+	int rval;
 
-	acp->flags = AAC_CMD_SYNC | AAC_CMD_IN_SYNC_SLOT;
-	if (softs->state & AAC_STATE_INTR)
-		acp->flags |= AAC_CMD_NO_CB;
-	else
-		acp->flags |= AAC_CMD_NO_INTR;
+	/* Sync fib only supports 512 bytes */
+	if (fibsize > AAC_FIB_SIZE)
+		return (AACERR);
 
-	acp->ac_comp = aac_sync_complete;
-	acp->timeout = AAC_SYNC_TIMEOUT;
-	acp->fib_size = fibsize;
-
 	/*
-	 * Only need to setup sync fib header, caller should have init
-	 * fib data
+	 * Setup sync fib
+	 * Need not reinitialize FIB header if it's already been filled
+	 * by others like aac_cmd_fib_scsi as aac_cmd.
 	 */
-	aac_cmd_fib_header(softs, acp, cmd);
+	if (slotp->acp == NULL)
+		aac_cmd_fib_header(softs, slotp, cmd, fibsize);
 
-	(void) ddi_dma_sync(acp->slotp->fib_dma_handle, 0, fibsize,
-	    DDI_DMA_SYNC_FORDEV);
+	(void) ddi_dma_sync(dma, 0, fibsize, DDI_DMA_SYNC_FORDEV);
 
-	aac_start_io(softs, acp);
+	/* Give the FIB to the controller, wait for a response. */
+	softs->sync_slot_busy = 1;
+	rval = aac_sync_mbcommand(softs, AAC_MONKER_SYNCFIB,
+	    slotp->fib_phyaddr, 0, 0, 0, &status, NULL);
+	if (rval == AACERR) {
+		AACDB_PRINT(softs, CE_WARN,
+		    "Send sync fib to controller failed");
+		return (AACERR);
+	}
 
-	if (softs->state & AAC_STATE_INTR)
-		return (aac_do_sync_io(softs, acp));
-	else
-		return (aac_do_poll_io(softs, acp));
+	(void) ddi_dma_sync(dma, 0, AAC_FIB_SIZE, DDI_DMA_SYNC_FORCPU);
+
+	if ((aac_check_acc_handle(softs->pci_mem_handle[0]) != DDI_SUCCESS) ||
+	    (aac_check_dma_handle(dma) != DDI_SUCCESS)) {
+		aac_fm_service_impact(softs->devinfo_p, DDI_SERVICE_UNAFFECTED);
+		return (AACERR);
+	}
+
+	return (AACOK);
 }
 
 static void
@@ -3211,11 +3056,11 @@
 	ASSERT(queue == AAC_ADAP_NORM_CMD_Q || queue == AAC_ADAP_NORM_RESP_Q);
 
 	/* Get the producer/consumer indices */
-	(void) ddi_dma_sync(dma, (uintptr_t)softs->qtablep->qt_qindex[queue] - \
-	    (uintptr_t)softs->comm_space, sizeof (uint32_t) * 2,
+	(void) ddi_dma_sync(dma, (uint8_t *)softs->qtablep->qt_qindex[queue] - \
+	    (uint8_t *)softs->comm_space, sizeof (uint32_t) * 2,
 	    DDI_DMA_SYNC_FORCPU);
 	if (aac_check_dma_handle(dma) != DDI_SUCCESS) {
-		ddi_fm_service_impact(softs->devinfo_p, DDI_SERVICE_UNAFFECTED);
+		aac_fm_service_impact(softs->devinfo_p, DDI_SERVICE_UNAFFECTED);
 		return (AACERR);
 	}
 
@@ -3238,8 +3083,8 @@
 	/* Fill in queue entry */
 	ddi_put32(acc, &((softs->qentries[queue] + pi)->aq_fib_size), fib_size);
 	ddi_put32(acc, &((softs->qentries[queue] + pi)->aq_fib_addr), fib_addr);
-	(void) ddi_dma_sync(dma, (uintptr_t)(softs->qentries[queue] + pi) - \
-	    (uintptr_t)softs->comm_space, sizeof (struct aac_queue_entry),
+	(void) ddi_dma_sync(dma, (uint8_t *)(softs->qentries[queue] + pi) - \
+	    (uint8_t *)softs->comm_space, sizeof (struct aac_queue_entry),
 	    DDI_DMA_SYNC_FORDEV);
 
 	/* Update producer index */
@@ -3246,8 +3091,8 @@
 	ddi_put32(acc, &softs->qtablep->qt_qindex[queue][AAC_PRODUCER_INDEX],
 	    pi + 1);
 	(void) ddi_dma_sync(dma,
-	    (uintptr_t)&softs->qtablep->qt_qindex[queue][AAC_PRODUCER_INDEX] - \
-	    (uintptr_t)softs->comm_space, sizeof (uint32_t),
+	    (uint8_t *)&softs->qtablep->qt_qindex[queue][AAC_PRODUCER_INDEX] - \
+	    (uint8_t *)softs->comm_space, sizeof (uint32_t),
 	    DDI_DMA_SYNC_FORDEV);
 
 	if (aac_qinfo[queue].notify != 0)
@@ -3272,8 +3117,8 @@
 	ASSERT(idxp);
 
 	/* Get the producer/consumer indices */
-	(void) ddi_dma_sync(dma, (uintptr_t)softs->qtablep->qt_qindex[queue] - \
-	    (uintptr_t)softs->comm_space, sizeof (uint32_t) * 2,
+	(void) ddi_dma_sync(dma, (uint8_t *)softs->qtablep->qt_qindex[queue] - \
+	    (uint8_t *)softs->comm_space, sizeof (uint32_t) * 2,
 	    DDI_DMA_SYNC_FORCPU);
 	pi = ddi_get32(acc,
 	    &softs->qtablep->qt_qindex[queue][AAC_PRODUCER_INDEX]);
@@ -3299,11 +3144,11 @@
 		ci = 0;
 
 	/* Fetch the entry */
-	(void) ddi_dma_sync(dma, (uintptr_t)(softs->qentries[queue] + pi) - \
-	    (uintptr_t)softs->comm_space, sizeof (struct aac_queue_entry),
+	(void) ddi_dma_sync(dma, (uint8_t *)(softs->qentries[queue] + pi) - \
+	    (uint8_t *)softs->comm_space, sizeof (struct aac_queue_entry),
 	    DDI_DMA_SYNC_FORCPU);
 	if (aac_check_dma_handle(dma) != DDI_SUCCESS) {
-		ddi_fm_service_impact(softs->devinfo_p, DDI_SERVICE_UNAFFECTED);
+		aac_fm_service_impact(softs->devinfo_p, DDI_SERVICE_UNAFFECTED);
 		return (AACERR);
 	}
 
@@ -3329,8 +3174,8 @@
 	ddi_put32(acc, &softs->qtablep->qt_qindex[queue][AAC_CONSUMER_INDEX],
 	    ci + 1);
 	(void) ddi_dma_sync(dma,
-	    (uintptr_t)&softs->qtablep->qt_qindex[queue][AAC_CONSUMER_INDEX] - \
-	    (uintptr_t)softs->comm_space, sizeof (uint32_t),
+	    (uint8_t *)&softs->qtablep->qt_qindex[queue][AAC_CONSUMER_INDEX] - \
+	    (uint8_t *)softs->comm_space, sizeof (uint32_t),
 	    DDI_DMA_SYNC_FORDEV);
 
 	if (unfull && aac_qinfo[queue].notify != 0)
@@ -3338,11 +3183,14 @@
 	return (AACOK);
 }
 
+/*
+ * Request information of the container cid
+ */
 static struct aac_mntinforesp *
-aac_get_mntinfo(struct aac_softstate *softs, int cid)
+aac_get_container_info(struct aac_softstate *softs, int cid)
 {
-	ddi_acc_handle_t acc = softs->sync_ac.slotp->fib_acc_handle;
-	struct aac_fib *fibp = softs->sync_ac.slotp->fibp;
+	ddi_acc_handle_t acc = softs->sync_slot->fib_acc_handle;
+	struct aac_fib *fibp = softs->sync_slot->fibp;
 	struct aac_mntinfo *mi = (struct aac_mntinfo *)&fibp->data[0];
 	struct aac_mntinforesp *mir;
 
@@ -3367,37 +3215,26 @@
 static int
 aac_get_container_count(struct aac_softstate *softs, int *count)
 {
-	ddi_acc_handle_t acc;
+	ddi_acc_handle_t acc = softs->sync_slot->fib_acc_handle;
 	struct aac_mntinforesp *mir;
-	int rval;
 
-	(void) aac_sync_fib_slot_bind(softs, &softs->sync_ac);
-	acc = softs->sync_ac.slotp->fib_acc_handle;
-
-	if ((mir = aac_get_mntinfo(softs, 0)) == NULL) {
-		rval = AACERR;
-		goto finish;
-	}
+	if ((mir = aac_get_container_info(softs, 0)) == NULL)
+		return (AACERR);
 	*count = ddi_get32(acc, &mir->MntRespCount);
 	if (*count > AAC_MAX_LD) {
 		AACDB_PRINT(softs, CE_CONT,
 		    "container count(%d) > AAC_MAX_LD", *count);
-		rval = AACERR;
-		goto finish;
+		return (AACERR);
 	}
-	rval = AACOK;
-
-finish:
-	aac_sync_fib_slot_release(softs, &softs->sync_ac);
-	return (rval);
+	return (AACOK);
 }
 
 static int
 aac_get_container_uid(struct aac_softstate *softs, uint32_t cid, uint32_t *uid)
 {
-	ddi_acc_handle_t acc = softs->sync_ac.slotp->fib_acc_handle;
+	ddi_acc_handle_t acc = softs->sync_slot->fib_acc_handle;
 	struct aac_Container *ct = (struct aac_Container *) \
-	    &softs->sync_ac.slotp->fibp->data[0];
+	    &softs->sync_slot->fibp->data[0];
 
 	bzero(ct, sizeof (*ct) - CT_PACKET_SIZE);
 	ddi_put32(acc, &ct->Command, VM_ContainerConfig);
@@ -3414,78 +3251,44 @@
 	return (AACOK);
 }
 
-/*
- * Request information of the container cid
- */
-static struct aac_mntinforesp *
-aac_get_container_info(struct aac_softstate *softs, int cid)
-{
-	ddi_acc_handle_t acc = softs->sync_ac.slotp->fib_acc_handle;
-	struct aac_mntinforesp *mir;
-	int rval_uid;
-	uint32_t uid;
-
-	/* Get container UID first so that it will not overwrite mntinfo */
-	rval_uid = aac_get_container_uid(softs, cid, &uid);
-
-	/* Get container basic info */
-	if ((mir = aac_get_mntinfo(softs, cid)) == NULL) {
-		AACDB_PRINT(softs, CE_CONT,
-		    "query container %d info failed", cid);
-		return (NULL);
-	}
-	if (ddi_get32(acc, &mir->MntObj.VolType) == CT_NONE)
-		return (mir);
-	if (rval_uid != AACOK) {
-		AACDB_PRINT(softs, CE_CONT,
-		    "query container %d uid failed", cid);
-		return (NULL);
-	}
-
-	ddi_put32(acc, &mir->Status, uid);
-	return (mir);
-}
-
-static enum aac_cfg_event
+static int
 aac_probe_container(struct aac_softstate *softs, uint32_t cid)
 {
-	enum aac_cfg_event event = AAC_CFG_NULL_NOEXIST;
 	struct aac_container *dvp = &softs->containers[cid];
+	ddi_acc_handle_t acc = softs->sync_slot->fib_acc_handle;
 	struct aac_mntinforesp *mir;
-	ddi_acc_handle_t acc;
+	uint64_t size;
+	uint32_t uid;
 
-	(void) aac_sync_fib_slot_bind(softs, &softs->sync_ac);
-	acc = softs->sync_ac.slotp->fib_acc_handle;
-
 	/* Get container basic info */
-	if ((mir = aac_get_container_info(softs, cid)) == NULL) {
-		/* AAC_CFG_NULL_NOEXIST */
-		goto finish;
-	}
+	if ((mir = aac_get_container_info(softs, cid)) == NULL)
+		return (AACERR);
 
 	if (ddi_get32(acc, &mir->MntObj.VolType) == CT_NONE) {
-		if (AAC_DEV_IS_VALID(&dvp->dev)) {
+		if (dvp->dev.valid) {
 			AACDB_PRINT(softs, CE_NOTE,
 			    ">>> Container %d deleted", cid);
-			dvp->dev.flags &= ~AAC_DFLAG_VALID;
-			event = AAC_CFG_DELETE;
+			dvp->dev.valid = 0;
+			(void) aac_dr_event(softs, dvp->cid, -1,
+			    AAC_DEV_OFFLINE);
 		}
-		/* AAC_CFG_NULL_NOEXIST */
 	} else {
-		uint64_t size;
-		uint32_t uid;
+		size = AAC_MIR_SIZE(softs, acc, mir);
 
-		event = AAC_CFG_NULL_EXIST;
+		/* Get container UID */
+		if (aac_get_container_uid(softs, cid, &uid) == AACERR) {
+			AACDB_PRINT(softs, CE_CONT,
+			    "query container %d uid failed", cid);
+			return (AACERR);
+		}
+		AACDB_PRINT(softs, CE_CONT, "uid=0x%08x", uid);
 
-		size = AAC_MIR_SIZE(softs, acc, mir);
-		uid = ddi_get32(acc, &mir->Status);
-		if (AAC_DEV_IS_VALID(&dvp->dev)) {
+		if (dvp->dev.valid) {
 			if (dvp->uid != uid) {
 				AACDB_PRINT(softs, CE_WARN,
 				    ">>> Container %u uid changed to %d",
 				    cid, uid);
 				dvp->uid = uid;
-				event = AAC_CFG_CHANGE;
 			}
 			if (dvp->size != size) {
 				AACDB_PRINT(softs, CE_NOTE,
@@ -3492,7 +3295,6 @@
 				    ">>> Container %u size changed to %"PRIu64,
 				    cid, size);
 				dvp->size = size;
-				event = AAC_CFG_CHANGE;
 			}
 		} else { /* Init new container */
 			AACDB_PRINT(softs, CE_NOTE,
@@ -3503,7 +3305,7 @@
 			    ddi_get32(acc, &mir->MntObj.Capacity),
 			    ddi_get32(acc, &mir->MntObj.VolType),
 			    mir->MntObj.FileSystemName);
-			dvp->dev.flags |= AAC_DFLAG_VALID;
+			dvp->dev.valid = 1;
 			dvp->dev.type = AAC_DEV_LD;
 
 			dvp->cid = cid;
@@ -3511,14 +3313,11 @@
 			dvp->size = size;
 			dvp->locked = 0;
 			dvp->deleted = 0;
-
-			event = AAC_CFG_ADD;
+			(void) aac_dr_event(softs, dvp->cid, -1,
+			    AAC_DEV_ONLINE);
 		}
 	}
-
-finish:
-	aac_sync_fib_slot_release(softs, &softs->sync_ac);
-	return (event);
+	return (AACOK);
 }
 
 /*
